capture program drop frank
*!v.1.2.0 by Florian Wendelspiess Chavez Juarez, December 2011
program define frank, rclass 
version 8.2
syntax varlist(max=1) [if] [in] [,noPRInt Quant QVar(str) QNum(str) GRoup(str)] Rvar(str) 

marksample touse
quietly{
*-********************
	local qvar="`qvar'"
	local qnum="`qnum'"
	if("`quant'"=="quant"){
		if("`qvar'"==""){
		local qvar="_quantile"
		}
		if("`qnum'"==""){
		local qnum=5
		}
		gen `qvar'=.
		} // end if quant
*********************

if "`group'"=="group"{
levelsof `group', local(levels)
gen `rvar'=.
foreach level of local levels{

	tempvar rank  
	egen `rank'=rank(`varlist') if `touse' & `group'==`level'
	sum `rank'
	replace `rvar'=(`rank')/(r(max)) if `touse' & `group'==`level'
	drop `rank'
	
	

	if("`quant'"=="quant"){
		replace `qvar'=int(`qnum'*`rvar'+0.999999) if `touse' & `group'==`level'
		replace `qvar'=`qnum' if `qvar'>`qnum' & `touse' & `group'==`level'
	} //end if quant

	} // end foreach level
} //end if group
else{
	tempvar rank  
	egen `rank'=rank(`varlist') if `touse' 
	sum `rank'
	gen `rvar'=(`rank')/(r(max)) if `touse'
	drop `rank'
	
	
	if("`quant'"=="quant"){
		replace `qvar'=int(`qnum'*`rvar'+0.999999) if `touse'
		replace `qvar'=`qnum' if `qvar'>`qnum' & `touse'
		} // end if quant 
		} // end else (no groups)
}
end
